/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2006, 2012. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package com.WebViewOverlaySample;

import org.apache.cordova.api.Plugin;
import org.apache.cordova.api.PluginResult;
import org.json.JSONArray;

import android.util.Log;
import android.view.View;

public class WebViewOverlayPlugin extends Plugin {

	private final String ACTION_OPEN_URL = "open";
	private final String ACTION_CLOSE_WEBVIEWOVERLAY = "close";
	private final String ACTION_GO_BACK = "goBack";

	@Override
	public PluginResult execute(String action, JSONArray args, String callbackId) {
		PluginResult result;

		if (action.equals(ACTION_OPEN_URL)) {
			WebViewOverlaySample.thisapp.runOnUiThread(new Runnable() {
				public void run() {
					WebViewOverlaySample.clearWebViewOverlayHistory();
					WebViewOverlaySample.loadWebViewOverlay("http://m.ibm.com/");
					WebViewOverlaySample.setWebViewOverlayVisibility(View.VISIBLE);
					WebViewOverlaySample.requestWebViewOverlayFocus();
					WebViewOverlaySample.clearWebViewOverlayHistory();
				}
			});
			result = new PluginResult(PluginResult.Status.OK, "PluginResult :: opened");
		} else if (action.equals(ACTION_CLOSE_WEBVIEWOVERLAY)) {
			WebViewOverlaySample.thisapp.runOnUiThread(new Runnable() {
				public void run() {
					WebViewOverlaySample.loadWebViewOverlayContent("");
					WebViewOverlaySample.setWebViewOverlayVisibility(View.INVISIBLE);
					WebViewOverlaySample.clearWebViewOverlayHistory();
				}
			});
			result = new PluginResult(PluginResult.Status.OK, "PluginResult :: closed");
		} else if (action.equals(ACTION_GO_BACK)) {
			result = new PluginResult(PluginResult.Status.OK, "PluginResult :: back");
		} else
			result = new PluginResult(PluginResult.Status.INVALID_ACTION);

		return result;
	}

}
