/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2006, 2012. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package com.WebViewOverlaySample;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.FrameLayout;
import android.widget.RelativeLayout;

import com.worklight.androidgap.WLDroidGap;

public class WebViewOverlaySample extends WLDroidGap {
	private static WebView webViewOverlay;
	public static Activity thisapp;
	@Override
	public void onCreate(Bundle savedInstanceState) {
	   super.onCreate(savedInstanceState);
	   //DeviceAuthManager.getInstance().setProvisioningDelegate(<replace with your ProvisioningDelegate implementation>);
	   super.loadUrl(getWebMainFilePath());
			
		thisapp = this;

		WebViewClient webViewClient = new WebViewClient() {
			@Override
			public boolean shouldOverrideUrlLoading(WebView view, String url) {
				Log.d("WebViewOverlaySample", "webViewOverlay is openning :: " + url);
				view.loadUrl(url);
				return true;
			}
		};

		webViewOverlay = new WebView(this);
		webViewOverlay.setVisibility(View.INVISIBLE);
		webViewOverlay.setWebViewClient(webViewClient);

		RelativeLayout.LayoutParams webViewOverlayLayoutParams = new RelativeLayout.LayoutParams(
				RelativeLayout.LayoutParams.FILL_PARENT,
				RelativeLayout.LayoutParams.FILL_PARENT);
		webViewOverlayLayoutParams.setMargins(0, 65, 0, 0);
		webViewOverlay.setLayoutParams(webViewOverlayLayoutParams);
		webViewOverlay.getSettings().setJavaScriptEnabled(true);

		RelativeLayout rootRelativeLayout = new RelativeLayout(this);
		
		((FrameLayout)root.getParent()).removeAllViews();
		rootRelativeLayout.addView(root);
		rootRelativeLayout.addView(webViewOverlay);
		setContentView(rootRelativeLayout);
	}

	public static void loadWebViewOverlay(String url) {
		webViewOverlay.loadUrl(url);
	}

	public static void setWebViewOverlayVisibility(int visibility) {
		webViewOverlay.setVisibility(visibility);
	}

	public static void loadWebViewOverlayContent(String content) {
		webViewOverlay.loadData(content, "text/html", "UTF-8");
	}

	public static void requestWebViewOverlayFocus() {
		webViewOverlay.requestFocus();
	}

	public static boolean canWebViewOverlayGoBack() {
		return webViewOverlay.canGoBack();
	}

	public static void webViewOverlayGoBack() {
		if (webViewOverlay.canGoBack()) {
			webViewOverlay.goBack();
		}
	}

	public static void clearWebViewOverlayHistory() {
		webViewOverlay.clearHistory();
	}

}
